;;; DOL-System
;; Valvassori Mose -- 2001
;; $Id: dol.scm,v 1.9 2001/09/21 20:36:41 djedi Exp $




;; Calcule le lsys
;; lsys : le systeme que l'on calcule
;; n    : le nombre d'itration que l'on va ffectuer
(define (lsys-dol lsys n)
  (if (not (eq? (lsys-type lsys) 'dol))
      (error "Not a DOL system" lsys)

      (lsys-dol-product (lsys-w lsys) (lsys-prod lsys) n)
      ))
(lsys-add-generator 'dol lsys-dol)
(lsys-help-add-item 'lsys-dol "Process a DOL System.
")

;; Symbol : le symbol qui l'on cherche
;; prod   : les regles de production
(define-syntax lsys-dol-rule
  (syntax-rules ()
    ((lsys-dol-rule symbol prod)
     (lsys-assq symbol prod #f))))


;; string : la chaine initiale
;; prules : les rgles de production
;; n      : le nombre d'itration qu'il reste  effectuer
(define (lsys-dol-product string prules n)
  (if (zero? n)
      string
      (lsys-dol-product (lsys-dol-next-iter (reverse string) prules '()) prules (- n 1))))

;; string : la chaine initiale
;; prules : les rgles de production
;; result : la chaine resultat
(define (lsys-dol-next-iter string prules result)
  (if (null? string)
      result
      (lsys-dol-next-iter (cdr string) prules
			  (append
			   (let ((prod (lsys-dol-rule  (car string) prules))) ; cherche la regle de prod
			  	(if (eq? prod #f) ; si le sombol n'est pas dans la table
			  	    (list (car string))
				    prod))
			   result)
			  )))
