;;; DOL-System -- Algorithme "parcourt en profondeur"
;; Valvassori Mose -- 2001
;; $Id: dol2.scm,v 1.1 2001/09/21 20:36:41 djedi Exp $




;; Calcule le lsys
;; lsys : le systeme que l'on calcule
;; n    : le nombre d'itration que l'on va ffectuer
(define (lsys-dol2 lsys n)
  (if (not (eq? (lsys-type lsys) 'dol))
      (error "Not a DOL system" lsys)

      (lsys-dol2-product (lsys-w lsys) (lsys-prod lsys) n)
      ))
(lsys-add-generator 'dol lsys-dol2)
(lsys-help-add-item 'lsys-dol2 "Process a DOL System.
")

;; Symbol : le symbol qui l'on cherche
;; prod   : les regles de production
(define-syntax lsys-dol2-rule
  (syntax-rules ()
    ((lsys-dol2-rule symbol prod)
     (lsys-assq symbol prod (list symbol)))))

;; calcule la chaine de production
;; string : la chaine initiale
;; prules : les rgles de production
;; n      : le nombre d'itration qu'il reste  effectuer
;; result : la chaine resultat
(define (lsys-dol2-product string prules n)
  (if (zero? n)
      string
      (apply append (map (lambda (symb)
			   (lsys-dol2-product (lsys-dol2-rule symb prules)
					      prules 
					      (- n 1)))
			 string))))
