;;; L-System -- Examples
;; Valvassori Mose --- 2001
;; $Id: examples.scm,v 1.3 2001/09/21 20:36:41 djedi Exp $

;; un exemple de l-sys
(define adolsys '((type dol)
		  (name "A simple L-System")
		  (author "Valvassori Mose (typed)")
		  (description "The L-sys given in page 3 of\n  \"The Algoritmic beauty of Plants\"")
		  (w (b))
		  (prod ((a (a b))
			 (b (a))))
		  ))

(define sg '((type dol)
	     (name "Sierpinski gasket")
	     (author "Valvassori Mose (typed)")
	     (w (fr))
	     (prod ((fl (fr + fl + fr))
		    (fr (fl - fr - fl))))
	     (angle (/ PI 3))))

(define c10 '((type dol)
	      (w (F - F - F - F))
	      (prod ((F (F F - F + F - F - F F))))))

(define d10 '((type dol)
	      (w (F - F - F - F))
	      (prod ((F (F F - F - - F - F))))
	      (angle (/ PI 2))))

(define f1-8p9 '((type dol)
		 (w (F + F + F + F))
		 (prod ((F (F + f - F F + F + F F + F f + F F - f
			      + F F - F - F F - F f - F F F))
			(f (f f f f f f))))
		 (angle (/ PI 2))))

(define a25 '((type dol)
	      (w (F))
	      (prod ((F (F [ + F ] F [ - F ] F))))
	      (angle (/ (* 22.5 PI) 360))))

(define c25 '((type dol)
	      (w (F))
	      (prod ((F (F F - [ - F + F + F ] + [ + F - F - F ]))))
	      (angle (deg->rad 22.5))))



(define koch '((type dol)
	       (w (F - - F - - F))
	       (prod ((F (F + F - - F + F))))
	       (angle (/ PI 3))))

(define st '((type sol)
	       (w (F))
	       (prod ((F ((0.34 (F [ + F ] F [ - F ] F))
			  (0.33 (F [ + F ] F))
			  (0.33 (F [ - F ] F))
		      ))))
	       (description "A stochastic dol test")
	       (angle (/ PI 6))))

(define sc25 '((type sol)
	      (w (F))
	      (prod ((F (( 0.7 (F F - [ - F + F + F ] + [ + F - F - F ]))
			 ( 0.15 (F F  + [ + F - F - F ] -))
			 ( 0.15 (F F - [ - F + F + F ] +))
			 ))))
	      (angle (deg->rad 22.5))))

(define 3D '((type dol)
	      (w (A))
	      (prod ((A ([ & F  A ] / / / / / [ & F  A ] / / / / / / / [ & F  A ]))
		     (F (S / / / / / F))
		     (S (F ))))

	      (angle (deg->rad 22.5))))

(define aaa '((type dol)
	      (w (F))
	      (prod ((F (F F [ + F ] / [ + F ] / [ + F ]))))

	      (angle (deg->rad 30))))
