;;; L-System
;; Valvassori Mose --- 2001
;; $Id: lsys.scm,v 1.14 2001/09/21 20:36:41 djedi Exp $

;; Definition d'un l-sys:
;; On dfinit les l-sys par une liste d'association.
;; Les cls sont les suivantes:
;; type -- type du lsys
;;         dol : determinist context free L-system
;; w    -- initial word
;; prod -- production rules: alist ((symbol (rule)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Vous tes libre de dfinir votre propre (error err arg)
;; si celle-ci n'existe pas.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(use-modules (ice-9 slib))			  ; Charge la SLIB dans GUILE
(require 'macro-by-example)			  ; Dfinit (define-syntax)
						  ; Il faut la SLIB



(load "help.scm")
(load "general.scm")
(load "information.scm")
;;(load "dol.scm")
(load "dol2.scm")
(load "sol.scm")

(load "turtle.scm")
(load "turtle2.scm")
(load "turtle3d.scm")

(load "examples.scm")

(newline)
(display "  Type (lsys-help 'lsys-help) for help.")
(newline)
(display "  Try (lsys-generate-turtle-string sc25 4 simpleturtle2)")
(newline)
