;;; L-Systems -- turtle
;; Valvassori Mose -- 2001
;; $Id: turtle.scm,v 1.6 2001/06/20 20:40:23 djedi Exp $

(define lsys-turtle-ass '((F (turtle 'move-forward))
			  (f (turtle 'jump-forward))
			  (+ (turtle 'turn-right))
			  (- (turtle 'turn-left))
 			  ([ (turtle 'push))
			   (] (turtle 'pop))
			  (fl (turtle 'move-forward))
			  (fr (turtle 'move-forward))
			  ))


(define (turtle-string-to-turtle string lsys turtle)  ;;turtle-def angle-inc line-length)
;;;  (turtle-string-to-turtle-aux string turtle-def `(begin (define turtle (make-turtle ,angle-inc ,line-length)))))
  (turtle-string-to-turtle-aux string
			       (lsys-assq 'ass turtle '())
			       (eval 
				`(begin (define turtle (,(lsys-assq 'constructor turtle 0)
						       ,(lsys-assq 'output-file turtle 0)
						       ,(lsys-angle lsys)
						       ,(lsys-assq 'initial-angle turtle 0)
						       ,(lsys-assq 'segment-width turtle 1)
						       ,(lsys-assq 'segment-length turtle 5)))))))

(lsys-help-add-item 'turtle-string-to-turtle "(turtle-string-to-turtle string turtle-def angle-inc)

Generate a turtle program from the string")


(define (turtle-string-to-turtle-aux string turtle-def result)
  (if (null? string)
      result
      (turtle-string-to-turtle-aux (cdr string) turtle-def
				   `(,@result ,(lsys-assq (car string) turtle-def #f)))))



(define (make-turtle file angle-inc angle-init line-width line-length)
  (let ((turtle-x 100)
	(turtle-y 300)
	(turtle-angle angle-init)
	(turtle-segment-length line-length)
	(turtle-angle-step angle-inc)  ;(/ 3.14159 2)
	(stack '())
	(out (open-output-file file)))
    (define (turtle-move-forward)
      (let* ((x turtle-x)
	     (y turtle-y)
	     (x1 (+ x (* turtle-segment-length (cos turtle-angle))))
	     (y1 (+ y (* turtle-segment-length (sin turtle-angle)))))
	(set! turtle-x x1)
	(set! turtle-y y1)
	(turtle-trace-segment2D x y x1 y1)
	))
    (define (turtle-jump-forward)
      (let* ((x turtle-x)
	     (y turtle-y)
	     (x1 (+ x (* turtle-segment-length (cos turtle-angle))))
	     (y1 (+ y (* turtle-segment-length (sin turtle-angle)))))
	(set! turtle-x x1)
	(set! turtle-y y1)
	;;	(turtle-trace-segment2D x y x1 y1)
	))
    (define (turtle-turn-left)
      (display "% (turn-left)" out) (newline out)
      (set! turtle-angle (- turtle-angle turtle-angle-step)))
    (define (turtle-turn-right)
      (display "% (turn-right)" out) (newline out)
      (set! turtle-angle (+ turtle-angle turtle-angle-step)))
    (define (turtle-push)
      (display "% (push)" out) (newline out)
      (set! stack (cons (list turtle-x turtle-y turtle-angle) stack)))
    (define (turtle-pop)
      (let ((t (car stack)))
	(display "% (pop)" out) (newline out)
	(set! stack (cdr stack))
	(set! turtle-x (car t))
	(set! turtle-y (cadr t))
	(set! turtle-angle (caddr t))))
    (define (turtle-trace-segment2D x y x1 y1)
      (display "% (move-forward)" out) (newline out)
      (display x out)
      (display " " out)
      (display y out)
      (display " moveto " out)
      (display x1 out)
      (display " " out)
      (display y1 out)
      (display " lineto stroke" out)
      (newline out))

    (display line-width out)
    (display " setlinewidth" out) (newline out)
    (lambda (mesg)
      (case mesg
	((move-forward)
	 (turtle-move-forward))
	((jump-forward)
	 (turtle-jump-forward))
	((turn-left)
	 (turtle-turn-left))
	((turn-right)
	 (turtle-turn-right))
	((push)
	 (turtle-push))
	((pop)
	 (turtle-pop))
	((close)
	 (display "showpage"out )(newline out)
	 (close-output-port out)))
      )))




(define simpleturtle `((lsys2turtle ,turtle-string-to-turtle)
		       (ass ,lsys-turtle-ass)
		       (constructor make-turtle)
		       (segment-length 5)
		       (segment-width 0.1)
		       (initial-angle 0)
		       (output-file "/tmp/a.ps")
		       ))
