;;; L-Systems -- turtle
;; Valvassori Mose -- 2001
;; $Id: turtle2.scm,v 1.5 2001/06/20 21:53:44 djedi Exp $

(define lsys-turtle2-ass '((F A)
			   (f a)
			   (+ C)
			   (- T)
			   ([ G)
			    (] g)
			   (fl A)
			   (fr A)
			   ))

(define (turtle2-parse-string string out)
  (let ((c 0))
    (for-each (lambda (x)
		(if (= c 16000)
		    (begin
		      (set! c 0)
		      (display "]\n[" out)))
		(set! c (+ 1 c))
		(display (string-append "/" (symbol->string (lsys-assq x lsys-turtle2-ass x))) out)) string)))


;; Construit le fichier postscript
(define (turtle2-string-to-turtle string lsys turtle)
  (let ((out (open-output-file (lsys-assq 'output-file turtle 0))))
    
    (display "%!PS-Adobe-3.0 EPSF-3.0
%%BoundingBox: 0 0 595 842
%%Title: Lsystem Turtle
%%Creator: Valvassori Mose
%%CreationDate:
%%EndComments

64 dict begin
/ms 1000 array def
/ix 0 def

%/pi 3.14159 def

/s [[
" out)
    (turtle2-parse-string string out)
    (display "]] def
/dct <<
" out)
    (display "/A /lf
  /a /mf
  /C /rt
  /T /lt
  /G /pu
  /g /po
" out)
    (display ">> def

/a " out)
    (display (rad->deg (lsys-assq 'initial-angle turtle 0)) out)
    (display " def
/x 250 def
/y 50 def

/sl " out)
    (display (lsys-assq 'segment-length turtle 0) out)
    (display " def	% segment length
/ai " out)
    (display (rad->deg (eval (lsys-angle lsys))) out)
    (display " def	% angle increment

/lf {
  x y moveto
  /x a cos sl mul x add def
  /y a sin sl mul y add def
  x y lineto stroke
} def

/rt {
  /a a ai add def
} def
/lt {
  /a a ai sub def
} def
/mf {
  /x a cos sl mul x add def
  /y a sin sl mul y add def
} def
/pu {
  /ix 1 ix add def
  ms ix [x y a] put
} def
/po {
  /tmp ms ix get def
  /x tmp 0 get def
  /y tmp 1 get def
  /a tmp 2 get def
  /ix ix 1 sub def
} def

" out)
    (display (lsys-assq 'segment-width turtle 0) out)
    (display " setlinewidth
x y moveto
s{
/t exch def
t{
/t1 exch def
dct t1 get cvx exec
}forall
} forall
end
showpage
%%EOF
" out)
    (close-output-port out)
    ))

(define simpleturtle2 `((lsys2turtle ,turtle2-string-to-turtle)
			(dict ,lsys-turtle2-ass)
			(constructor make-turtle)
			(segment-length 5)
			(segment-width 1)
			(initial-angle ,(/ PI 2))
			(output-file "/tmp/a.ps")
			))
