;;; L-Systems -- turtle 3D
;; Valvassori Mose -- 2001
;; $Id: turtle3d.scm,v 1.1 2001/04/26 10:13:25 djedi Exp $

(define lsys-turtle3d-ass '((F (turtle 'move-forward))
			  (f (turtle 'jump-forward))
			  (- (turtle 'turn-right))
			  (+ (turtle 'turn-left))
			  (& (turtle 'pitch-down))
			  (^ (turtle 'pitch-up))
			  (/ (turtle 'roll-right))
			  (\ (turtle 'roll-left))
			  (| (turtle 'turn-around))
 			  ([ (turtle 'push))
 			  (] (turtle 'pop))
			  (fl (turtle 'move-forward))
			  (fr (turtle 'move-forward))
			  (A (turtle 'move-forward))
			  (S (turtle 'move-forward))
			  ))


; (define (turtle-string-to-turtle string lsys turtle)  ;;turtle-def angle-inc line-length)
; ;;;  (turtle-string-to-turtle-aux string turtle-def `(begin (define turtle (make-turtle ,angle-inc ,line-length)))))
;   (turtle-string-to-turtle-aux string 
; 			       (lsys-assq 'ass turtle '())
; 			       `(begin (define turtle (,(lsys-assq 'constructor turtle 0)
; 						       ,(lsys-assq 'output-file turtle 0)
; 						       ,(lsys-angle lsys)
; 						       ,(lsys-assq 'initial-angle turtle 0)
; 						       ,(lsys-assq 'segment-width turtle 1)
; 						       ,(lsys-assq 'segment-length turtle 5))))))

(define simpleturtle3D `((lsys2turtle ,turtle-string-to-turtle)
		       (ass ,lsys-turtle3d-ass)
		       (constructor make-turtle3d)
		       (segment-length 15)
		       (segment-width 1)
		       (initial-angle 0)
		       (output-file "/tmp/a.ps")
))

; (define (turtle-string-to-turtle-aux string turtle-def result)
;   (if (null? string)
;       result
;       (turtle-string-to-turtle-aux (cdr string) turtle-def
; 				   `(,@result ,(lsys-assq (car string) turtle-def #f)))))



(define (make-turtle3d file angle-inc angle-init line-width line-length)
  (let ((x 0)
	(y 100)
	(z 300)
	(dx 0)
	(dy 0)
	(dz line-length)
	(xi 0)
	(yi 0)
	(zi line-length)
	(u 0)
	(h angle-init)
	(l 0)
	(turtle-angle-step angle-inc)  ;(/ 3.14159 2)
	(cs (cos angle-inc))
	(sn (sin angle-inc))
	(sni (- (sin angle-inc)))
	(stack '())
	(out (open-output-file file)))
    ; (define (update-dx)
    ;   (set! dx 
    ; 	    (- (+ (* zi (sin l))
    ; 		  (* xi (+ (cos l)
    ; 			   (cos u)
    ; 			   1)))
    ; 	       (* yi (sin u)))))
    ; (define (update-dy)
    ;   (set! dy
    ; 	    (+ (* zi (sin h))
    ; 	       (* yi (+ (cos h)
    ; 			(cos u)
    ; 			1))
    ; 	       (* xi (sin u)))))
    ; (define (update-dz)
    ;   (set! dz (* line-length (cos h)))
    ;   (set! dy (* line-length (sin h)))
      
    ;   (set! dx (* dz (cos l)))
    ;   (set! dz (* dz (sin l)))

    ;   (let ((t (sqrt (+ (* dz dz) (* dy dy)))))
    ;   (set! dx (* line-length (cos u)))
    ;   (set! dy (* line-length (sin u)))
    ;   ))
      ; (set! dz
      ; 	    (- (* zi (+ (cos h)
      ; 			(cos l)
      ; 			1))
      ; 	       (* yi (sin h))
      ; 	       (* xi (sin l)))))
    
    (define (turtle-move-forward)
      (let* ((x0 x)
	     (y0 y)
	     (z0 z)
	     (x1 (+ x dx))
	     (y1 (+ y dy))
	     (z1 (+ z dz)))
	(turtle-trace-segment3D y z x y1 z1 x1)
	(set! x x1)
	(set! y y1)
	(set! z z1)
	))
    (define (turtle-jump-forward)
      (let* ((x0 x)
	     (y0 y)
	     (z0 z)
	     (x1 (+ x dx))
	     (y1 (+ y dy))
	     (z1 (+ z dz)))
	(display "% (jump-forward)" out) (newline out)
	(set! x x1)
	(set! y y1)
	(set! z z1)
	))
    (define (turtle-turn-left)
      (display "% (turn-left)" out) (newline out)
      (let ((x dx))
	(set! dx (- (* dx cs) (* dy sn)))
	(set! dy (+ (* x sn) (* dy cs)))))

    (define (turtle-turn-right)
      (display "% (turn-right)" out) (newline out)
      (let ((x dx))
	(set! dx (- (* dx cs) (* dy sni)))
	(set! dy (+ (* x sni) (* dy cs)))))

    (define (turtle-turn-arround)
      (display "% (turn-right)" out) (newline out)
      (set! dx (- dx))
      (set! dy (- dy)))

    (define (turtle-pitch-down)
      (display "% (pitch-down)" out) (newline out)
      (let ((x dx))
	(set! dx (+ (* dx cs) (* dz sn)))
	(set! dz (- (* dz cs) (* x sn)))))

    (define (turtle-pitch-up)
      (display "% (pitch-up)" out) (newline out)
      (let ((x dx))
	(set! dx (+ (* dx cs) (* dz sni)))
	(set! dz (- (* dz cs) (* x sni)))))

    (define (turtle-roll-left)
      (display "% (roll-left)" out) (newline out)
      (let ((y dy))
	(set! dy (+ (* dz sn) (* dy cs)))
	(set! dz (- (* dz cs) (* y sn)))))

    (define (turtle-roll-right)
      (display "% (roll-right)" out) (newline out)
      (let ((y dy))
	(set! dy (+ (* dz sni) (* dy cs)))
	(set! dz (- (* dz cs) (* y sni)))))

    (define (turtle-push)
      (display "% (push)" out) (newline out)
      (set! stack (cons (list x y z dx dy dz) stack)))
    (define (turtle-pop)
      (let ((t (car stack)))
	(display "% (pop)" out) (newline out)
	(set! stack (cdr stack))
	(set! x (list-ref t 0))
	(set! y (list-ref t 1))
	(set! z (list-ref t 2))
	(set! dx (list-ref t 3))
	(set! dy (list-ref t 4))
	(set! dz (list-ref t 5))
	))
    (define (turtle-trace-segment3D x y z x1 y1 z1)
      (display "% (move-forward) " out) (newline out)

      (display (/ z 50) out)
      (display " setgray" out) (newline out)
      (display x out)
      (display " " out)
      (display y out)
      (display " moveto " out)
      (display x1 out)
      (display " " out)
      (display y1 out)
      (display " lineto stroke" out)
      (newline out))

    (display "% 3D" out) (newline out)
    (display line-width out)
    (display " setlinewidth" out) (newline out)
    (lambda (mesg)
      (case mesg
	((move-forward)
	 (turtle-move-forward))
	((jump-forward)
	 (turtle-jump-forward))
	((turn-left)
	 (turtle-turn-left))
	((turn-right)
	 (turtle-turn-right))
	((pitch-down)
	 (turtle-pitch-down))
	((pitch-up)
	 (turtle-pitch-up))
	((roll-left)
	 (turtle-roll-left))
	((roll-right)
	 (turtle-roll-right))
	((turn-around)
	 (turtle-turn-arround))
	((push)
	 (turtle-push))
	((pop)
	 (turtle-pop))
	((close)
	 (display "showpage" out )(newline out) 
	 (close-output-port out))
	(else 
	 (display "% mesg:" out)(display mesg out) (newline out)
	 ))
      )))
